<?php
    $wpshd_vcita_widget = (array)get_option(WPSHD_VCITA_WIDGET_KEY);
    if (!isset($wpshd_vcita_widget['wp_id'])) $wpshd_vcita_widget['wp_id'] = '';
    echo '<script>WPSHD_VCITA_DATA=' . json_encode($wpshd_vcita_widget) . ';</script>' . PHP_EOL;

    $needs_reconnect = wpshd_vcita_check_need_to_reconnect($wpshd_vcita_widget);
?>
<script type='module'>
<?php if (WPSHD_VCITA_DEBUG) echo 'console.log(' . json_encode($widget_data) . ')' . PHP_EOL ?>
document.addEventListener('DOMContentLoaded', () => {
    const vc = document.querySelector('.vcita-wrap');
    if (vc != null) vc.style.opacity = '1';
});
<?php echo WPSHD_VCITA_DEBUG ? 'window.WPSHD_VCITA_DEBUG=true;':'window.WPSHD_VCITA_DEBUG=false;'?>
<?php echo WPSHD_VCITA_DEBUG ? 'console.log(window.WPSHD_VCITA_DATA);':''?>
window.$_ajaxurl = '<?php echo admin_url('admin-ajax.php') ?>';
import { ApiController } from '/wp-content/plugins/<?php echo WPSHD_VCITA_WIDGET_UNIQUE_ID ?>/assets/js/proxy_connect.js';
import { UIController } from '/wp-content/plugins/<?php echo WPSHD_VCITA_WIDGET_UNIQUE_ID ?>/assets/js/utils.js';
import { MixpMan } from '/wp-content/plugins/<?php echo WPSHD_VCITA_WIDGET_UNIQUE_ID ?>/assets/js/mixpanel.js';
window.VcitaUI = new UIController('<?php echo plugins_url(WPSHD_VCITA_WIDGET_UNIQUE_ID) ?>',<?php echo json_encode($wpshd_vcita_widget) ?>);
window.VcitaApi = new ApiController('<?php echo $wpshd_vcita_widget['wp_id'] ?>','<?php echo WPSHD_VCITA_WIDGET_CALLBACK_URL ?>');
window.VcitaMixpman = new MixpMan('78aa39b3aa49594f172cfccda537ef1a','<?php echo $wpshd_vcita_widget['wp_id']?>','<?php echo $wpshd_vcita_widget['email']?>');

window.dispatchEvent(new CustomEvent('vcita_api_initialized', {
    bubbles: true,
    detail: { VcitaApi: VcitaApi }
}))

if (!VcitaApi.isInstalled()) {
    VcitaApi.install().then(function(data) {
        <?php if (WPSHD_VCITA_DEBUG) echo 'console.log(data);' ?>

        if (data.success && data.wp_id) {
            VcitaApi.wpid = data.wp_id;
            vcita_sync_business();

            VcitaApi.saveData('wp_id', data.wp_id)
                .then((res) => {});
        }
    }).catch(function (err) {
        console.log(err);
    });
} else vcita_sync_business();
<?php if ($wpshd_vcita_widget['migrated'] && (!isset($wpshd_vcita_widget['migrated_popup_showed']) || !$wpshd_vcita_widget['migrated_popup_showed']) && !WPSHD_VCITA_ANOTHER_PLUGIN) { ?>
VcitaUI.constructPopup({}, VcitaUI.getMigratedPopupHTML(<?php echo json_encode($wpshd_vcita_widget) ?>));
VcitaMixpman.track('wp_sched_upgrade');
<?php
    $wpshd_vcita_widget['migrated_popup_showed'] = true;
    update_option(WPSHD_VCITA_WIDGET_KEY, $wpshd_vcita_widget);
?>
<?php } ?>

function vcita_sync_business() {
    <?php if (WPSHD_VCITA_DEBUG) echo 'console.log(VcitaApi)' . PHP_EOL; ?>
    <?php if ($wpshd_vcita_widget['uid'] && !$needs_reconnect) { ?>
    const ac = document.querySelector('.vcita__page__alert-container');
    if (ac != null) ac.innerHTML = '';

    VcitaApi.getBusiness()
        .then((data) => {
            <?php if (WPSHD_VCITA_DEBUG) { ?>console.log(data);<?php } ?>
            const plan = data.plan;
            if (plan == undefined) return;
            if (ac == null) return;

            if (plan.expires_on != null && typeof plan.expires_on == 'string') {
                const d = new Date(plan.expires_on);
                const now = new Date();
                const vcita_premium_url = '<?php echo get_admin_url('','','admin').'admin.php?page='.WPSHD_VCITA_WIDGET_UNIQUE_ID.'/vcita-premium.php' ?>';

                if (d.getTime() < now.getTime()) {
                    ac.classList.add('vcita-danger');
                    ac.innerHTML = data.business_data.name + ', your trial ended. Please upgrade to enjoy vcita'+
                        '&nbsp;&nbsp;<a href="'+vcita_premium_url+'">Upgrade now</a>';
                } else if (d.getDate() - now.getDate() <= 7 && d.getMonth() == now.getMonth() && d.getFullYear() == now.getFullYear()) {
                    ac.classList.add('vcita-warning');
                    ac.innerHTML = data.business_data.name + ', your trial ends in '+(d.getDate() - now.getDate())+' days'+
                        '&nbsp;&nbsp;<a href="'+vcita_premium_url+'">Upgrade now</a>';
                }
            }
        })
        .catch((err) => { console.log(err); });
    <?php } ?>
}

jQuery(function ($) {
    $('.start-login')
        .click(function(ev){
            ev.preventDefault();
            ev.stopPropagation();
            VcitaMixpman.track('wp_sched_login_vcita');
            VcitaUI.openAuthWin(false, false);
        });
    $('.start-signup')
        .click(function() {
            VcitaMixpman.track('wp_sched_join_vcita', { tab: 'main' });
            VcitaUI.openAuthWin(true, false);
        });
    $('.start-signup-add')
        .click(function() {
            VcitaMixpman.track('wp_sched_join_vcita', { tab: 'add' });
            VcitaUI.openAuthWin(true, false);
        });
    $('#switch-account')
        .click(function(){
            VcitaMixpman.track('wp_sched_logout')
            jQuery.post('/wp-admin/admin-ajax.php?action=vcita_logout');
            VcitaUI.openAuthWin(false, true);
        });
    $('#vcita__input-email')
        .keypress(function(e){
            if (e.keyCode == 13) $('#start-signup').click();
        });
});
</script>
