<?php

function vcita_callback(WP_REST_Request $request)
{

    if (WPSHD_VCITA_DEBUG) error_log('------------------------------- NEW REQUEST RECEIVED -------------------------------');
    if (WPSHD_VCITA_DEBUG) error_log('Request method is ' . $request->get_method());
    if (WPSHD_VCITA_DEBUG) error_log('Request action is ' . $request['action']);

    if ($request->get_method() === 'POST') {
        $data = json_decode($request->get_body(), true);

        if (WPSHD_VCITA_DEBUG) {
            //error_log('Printing request body:');
            //error_log(print_r($data, true));
        }

        if (is_array($data)) {
            if (isset($data['success']) && $data['success']) {
                processAction($request['action'], $data);
            }
        }
    } else if ($request->get_method() === 'GET') {
        if ($request->get_param('method') == 'enc' && !is_null($request->get_param('d'))) {
            $data = base64_decode($request->get_param('d'));
            if ($data) $data = json_decode($data, true);
            if ($data && is_array($data)) processAction($request['action'], $data);
        }
    }

    if (WPSHD_VCITA_DEBUG) error_log('------------------------------------------------------------------------------------');
    exit;
}

function processAction($action, $data = array())
{
    if (WPSHD_VCITA_DEBUG) error_log('Processing action ' . $action);

    if ($action == 'install') {
        if (isset($data['wp_id'])) {
            $wpshd_vcita_widget['wp_id'] = $data['wp_id'];
            $status = update_option(WPSHD_VCITA_WIDGET_KEY, $wpshd_vcita_widget);
            echo json_encode(array('result' => 'OK', 'status' => $status));
        }
    } else if ($action == 'auth') {
        header('Content-Type: text/html');

        if ($data['success']) {
            $wpshd_vcita_widget = (array)get_option(WPSHD_VCITA_WIDGET_KEY);

            $wpshd_vcita_widget['success'] = $data['success'];
            $wpshd_vcita_widget['uid'] = $data['user_data']['business_id'];
            $wpshd_vcita_widget['business_id'] = $data['user_data']['business_id'];
            $wpshd_vcita_widget['name'] = $data['user_data']['business_name'];
            $wpshd_vcita_widget['email'] = $data['user_data']['email'];
            $status = update_option(WPSHD_VCITA_WIDGET_KEY, $wpshd_vcita_widget);

            if (WPSHD_VCITA_DEBUG) {
                error_log('Printing data:');
                error_log(print_r($data));
                error_log('Printing widget data:');
                error_log(print_r($wpshd_vcita_widget));
            }

            echo '<h1>Authentication OK</h1>
                  <script type="text/javascript">if(window.parent.VcitaUI!=undefined)window.parent.VcitaUI.hidePopup()</script>';
        } else if ($data['error']) {
            echo $data['message'] ? $data['message'] : 'some error occured';
        }
    }
}