<?php
    wp_enqueue_script('vcita_prism', '/wp-content/plugins/'.WPSHD_VCITA_WIDGET_UNIQUE_ID.'/assets/extra/prism/prism.js');
    wp_enqueue_script('vcita-custom-script', '/wp-content/plugins/'.WPSHD_VCITA_WIDGET_UNIQUE_ID.'/assets/js/custom.js');

    wp_enqueue_style('vcita-prism', '/wp-content/plugins/'.WPSHD_VCITA_WIDGET_UNIQUE_ID.'/assets/extra/prism/prism.css');
    wp_enqueue_style('vcita-custom-style', '/wp-content/plugins/'.WPSHD_VCITA_WIDGET_UNIQUE_ID.'/assets/style/custom.css');

    $wpshd_vcita_widget = (array) get_option(WPSHD_VCITA_WIDGET_KEY);
?>
<div class="vcita-wrap" dir="ltr">
    <?php require_once WP_PLUGIN_DIR.'/'.WPSHD_VCITA_WIDGET_UNIQUE_ID.'/php_assets/admin_header.php' ?>
    <div class="vcita__page__inner__section">
        <h3>
            Turn your own site elements into SMART booking buttons
            <small>Super simple HTML will enable you to use your own buttons and release the full power of vcita Scheduling.</small>
        </h3>
    </div>
    <div class="vcita__page__inner__section">
        <div class="vcita__custom__inner__section-banner">
            <div class="vcita__page__inner__section-banner-img">
                <img src="/wp-content/plugins/<?php echo WPSHD_VCITA_WIDGET_UNIQUE_ID ?>/images/dark(1).jpg" alt="phone mockup"/>
            </div>
            <section class="vcita__custom__inner__section-wrapper">
                <h3>
                    Scheduling Button
                    <small>Turn any element on your site into a scheduling button</small>
                </h3>
            </section>
            <section class="vcita__custom__inner__section-wrapper">
                <h4>You can design your own button and place it anywhere you want on your site. Once a visitor clicks on it, your scheduling page on vcita will open.</h4>
            </section class="vcita__custom__inner__section-wrapper">
            <!--
            <section>
                <a href="javascript:void(0)" onclick="vcita_get_sample_html(this)">Show sample HTML</a>
            </section>
            -->
            <section class="vcita__custom__inner__section-wrapper">
                <div class="vcita__page__inner__section-code">
                    <pre>
                        <code class="language-markup">
                            &lt;button class="livesite-schedule"&gt;Schedule now&lt;/button&gt;
                        </code>
                    </pre>
                </div>
            </section>
        </div>
    </div>
    <div class="vcita__page__inner__section">
        <div class="vcita__custom__inner__section-banner">
            <div class="vcita__page__inner__section-banner-img">
                <img src="/wp-content/plugins/<?php echo WPSHD_VCITA_WIDGET_UNIQUE_ID ?>/images/dark.jpg" alt="phone mockup"/>
            </div>
            <section class="vcita__custom__inner__section-wrapper">
                <h3>
                    Send Parameters
                    <small>Ease the scheduling process by adding parameters</small>
                </h3>
            </section>
            <section class="vcita__custom__inner__section-wrapper">
                <h4>Instead of making your clients manually fill the meeting details (i.e. choosing the service, time, price etc), you can simply send those as parameters when the user initiates the scheduling process.</h4>
            </section>
            <!--
            <section class="vcita__custom__inner__section-wrapper">
                <a href="javascript:void(0)" onclick="vcita_get_sample_html(this)">Show sample HTML</a>
            </section>
            -->
            <section class="vcita__custom__inner__section-wrapper">
                <div class="vcita__page__inner__section-code">
                    <pre>
                        <code class="language-markup">
                            &lt;!-- You can pass the parameters as one options string by using the data-options attribute --&gt;<br>
                            &lt;button class="livesite-schedule" data-options="date:01012020"&gt;Schedule now&lt;/button&gt;
                        </code>
                    </pre>
                </div>
            </section>
        </div>
    </div>
    <div class="vcita__page__inner__section">
        <h3>
            Using vcita’s LiveSite SDK
            <small>
                vCita LiveSite SDK offers a wealth of engagement tools to drive more business and deliver amazing customer service through your website. Please review the <a href="https://developers.vcita.com/reference#embedding-action" target="_blank" onclick="VcitaMixpman.track('wp_sched_read_more_faq')">full documentation</a> for more details
            </small>
        </h3>
        <div class="vcita__page__inner__section-code">
            <header>HTML</header>
            <pre>
				<code class="language-markup">
					&lt;!-- You can pass the parameters as one options string by using the data-options attribute --&gt;
					&lt;button class="livesite-contact" data-options="title:Registration to your English Class"&gt;Register to English Class&lt;/button&gt;
				</code>
            </pre>
        </div>
        <div class="vcita__page__inner__section-code">
            <header>JavaScript</header>
            <pre>
                <code class="language-js">
					LiveSite.schedule({email: email, first_name: first_name, last_name: last_name});
				</code>
			</pre>
        </div>
        <h4 style="margin-top:30px;margin-bottom:20px;font-weight:600">
            Parameters list
            <small>Below you will find the parameters that you can pass with every scheduling action. Using those parameters will help you provide a quick and smooth scheduling experience</small>
        </h4>
        <div>
            <table class="vcita__page__inner-table">
                <thead>
                    <tr>
                        <td>Option</td>
                        <td>Description</td>
                    </tr>
                </thead>
                <tbody>
                    <tr>
                        <td>date</td>
                        <td>Preselect date to show the scheduling on (MMDDYY or MMDDYYYY)</td>
                    </tr>
                    <tr>
                        <td>service</td>
                        <td>Preselect a service by it's uid</td>
                    </tr>
                    <tr>
                        <td>service_name</td>
                        <td>Show only services matching the name (only if service not provided)</td>
                    </tr>
                    <tr>
                        <td>staff</td>
                        <td>Preselect staff by it's uid</td>
                    </tr>
                    <tr>
                        <td>order</td>
                        <td>services_first (default) to show the service selection step before a staff is selected or staff_first to show the staff selection step first and then show the services selection according to the selected staff member</td>
                    </tr>
                    <tr>
                        <td>email</td>
                        <td>Pre-fill email for the appointment</td>
                    </tr>
                    <tr>
                        <td>first_name</td>
                        <td>Pre-fill first_name for the appointment</td>
                    </tr>
                    <tr>
                        <td>last_name</td>
                        <td>Pre-fill last_name for the appointment</td>
                    </tr>
                    <tr>
                        <td>phone</td>
                        <td>Pre-fill phone for the appointment</td>
                    </tr>
                    <tr>
                        <td>agenda</td>
                        <td>Pre-fill agenda for the appointment</td>
                    </tr>
                    <tr>
                        <td>source</td>
                        <td>Action source, will be displayed in the engagement</td>
                    </tr>
                </tbody>
            </table>
        </div>
    </div>
    <?php require_once WP_PLUGIN_DIR.'/'.WPSHD_VCITA_WIDGET_UNIQUE_ID.'/php_assets/admin_footer.php'; ?>
</div>


