<?php
    $wpshd_vcita_widget = (array)get_option(WPSHD_VCITA_WIDGET_KEY);
    $uid = $wpshd_vcita_widget['uid'];
    $needs_reconnect = wpshd_vcita_check_need_to_reconnect($wpshd_vcita_widget);
    $av_plugin_list = wp_cache_get('WPSHD_VCITA_ANOTHER_PLUGIN_LIST');
?>

<div class="vcita-wrap" dir="ltr">
<?php require_once WP_PLUGIN_DIR."/".WPSHD_VCITA_WIDGET_UNIQUE_ID.'/php_assets/admin_header.php' ?>
<?php if (WPSHD_VCITA_ANOTHER_PLUGIN) { ?>
    <?php if ($av_plugin_list) { ?>
        <?php $plugin_str = ''; ?>
        <?php foreach ($av_plugin_list as $vcita_plugin_data) {
            $plugin_str .= ' or ' . $vcita_plugin_data["Name"];
        }

        $plugin_str = substr($plugin_str, 4);
        ?>
        <div class="vcita__page__error-container">
            As you already use <b><?php echo $plugin_str ?></b> by vcita, you can edit the scheduling widget there.
            Alternatively you can deactivate all other vcita plugins installed on your site and configure your scheduling
            widget using this plugin. Set up widget using <a href="<?php echo get_admin_url('','','admin').'admin.php?page='.urlencode($vcita_plugin_data['url']) ?>"><?php echo $plugin_str ?></a> or
            <a href="javascript:void(0)" onclick="jQuery.ajax({'url':'/wp-admin/admin-ajax.php?action=vcita_deactivate_others&rescan=1','method':'GET','success':(resp)=>{try{if(resp=='success'){window.location.reload()}else{VcitaUI.hidePopup()}}catch(err){console.log(err)}}})">
                deactivate all other vcita plugins
            </a></div>
    <?php } ?>
<?php } else { ?>
    <?php if (!empty($uid) || $needs_reconnect) { ?>
        <div class="vcita__page__inner__section">
            <h3>
                Hi
                <?php if ($needs_reconnect) { ?>
                <small>
                    Re-connect below to continue to settings and edit your plugin.
                </small>
                <?php } else { ?>
                <small>Quickly configure your online booking settings with our online booking wizard</small>
                <?php } ?>
            </h3>
            <?php if ($needs_reconnect) { ?>
            <div>
                <button class="vcita__btn__blue start-login clickme">Connect to vcita</button>
            </div>
            <?php } else { ?>
            <div>
                <button class="vcita__btn__blue <?php echo (!isset($wpshd_vcita_widget['start_wizard_clicked']) || !$wpshd_vcita_widget['start_wizard_clicked'] ? 'clickme' : '') ?>" onclick="VcitaUI.openEditSettingsWin(event);vcita_save_start_wizard(this)">Start Wizard</button>
            </div>
            <?php } ?>
        </div>
    <?php } else { ?>
        <div class="vcita__page__inner__section">
            <h3 class="hcentered">Get started by signing up to vcita</h3>
            <div class="txt_input_wrapper hcentered">
                <!--<input type="text" placeholder="Enter your email" style="width: 251px;" class="txt_input sm-full-width" id="vcita__input-email">-->
                <button class="vcita__btn__blue start-signup clickme" id="start-signup">Sign up</button>
            </div>
            <div class="vcita__page__inner__section-footer">
                <a href="javascript:void(0)" class="start-login">Login</a>
            </div>
        </div>
    <?php } ?>
    <?php if (empty($uid)) { ?>
        <!--
        <div class="vcita__page__inner__section">
            <h3 class="hcentered">What do you get for FREE!</h3>
            <div>
                <div class="vcita__main__page-banner1-container flex hspaced">
                    <div class="vcita__main__page-banner1-wrapper">
                        <div><img src="/wp-content/plugins/<?php echo WPSHD_VCITA_WIDGET_UNIQUE_ID; ?>/images/assets/unlimited-booking.svg"/></div>
                        UNLIMITED bookings
                    </div>
                    <div class="vcita__main__page-banner1-wrapper">
                        <div><img src="/wp-content/plugins/<?php echo WPSHD_VCITA_WIDGET_UNIQUE_ID; ?>/images/assets/2-way-sync.svg"/></div>
                        2 Way sync
                    </div>
                    <div class="vcita__main__page-banner1-wrapper">
                        <div><img src="/wp-content/plugins/<?php echo WPSHD_VCITA_WIDGET_UNIQUE_ID; ?>/images/assets/email-reminders.svg"/></div>
                        Email reminders
                    </div>
                </div>
            </div>
        </div>
        -->
        <div class="vcita__page__inner__section">
            <h3 class="hcentered">Watch how vcita’s online booking works!</h3>
            <div class="vcita__page__main-video">
                <i></i>
                <img src="/wp-content/plugins/<?php echo WPSHD_VCITA_WIDGET_UNIQUE_ID; ?>/images/preview.png" />
            </div>
        </div>
    <?php } else if (!$needs_reconnect) { ?>
        <div class="vcita__page__inner__section">
            <h3>
                Your availability hours
                <small>
                    Set the time during which clients can book meetings with you.
                    <a href="javascript:void(0)" onclick="VcitaUI.openEditAvailabilityWin(event)">Edit availbility</a>
                </small>
            </h3>
            <div id="vcita__time__slots">
                <mark class="vcita__preloader__container">
                    <div class="lds-ring"><div></div><div></div><div></div><div></div></div>
                </mark>
            </div>
        </div>
        <div class="vcita__page__inner__section">
            <h3>
                Your services
                <small>
                    Here are the services your clients can book with you. You can <a href="javascript:void(0)" onclick="VcitaUI.openEditServicesWin(event)">add / edit</a> more services
                </small>
            </h3>
            <div class="vcita__services__list">
                <mark class="vcita__preloader__container">
                    <div class="lds-ring"><div></div><div></div><div></div><div></div></div>
                </mark>
            </div>
        </div>
        <div class="vcita__page__inner__section">
            <h3>
                Sync your Calendars
                <small>Sync your Outlook, iCal or  Google Calendar with vcita to efficiently manage your calendar & avoid double bookings</small>
            </h3>
            <div><button class="vcita__btn__blue" onclick="VcitaUI.openSyncCalendarWin(event)">Sync calendar</button></div>
        </div>
    <?php } ?>
<?php } ?>
<?php require_once WP_PLUGIN_DIR.'/'.WPSHD_VCITA_WIDGET_UNIQUE_ID.'/php_assets/admin_footer.php'; ?>
</div>
<?php if (!WPSHD_VCITA_ANOTHER_PLUGIN) { ?>
<?php if ($uid && !$needs_reconnect) { ?>
    <script typ="text/javascript">
        function vcita_fetch_availability(add_preloader = false) {
            const days = ['Sunday', 'Monday', 'Tuesday', 'Wednesday', 'Thursday', 'Friday', 'Saturday'];
            let avc = document.getElementById('vcita__time__slots');
            if (avc == null) return;
            if (add_preloader) avc.innerHTML = VcitaUI.createPreloaderHTML();

            VcitaApi.getAvailability()
                .then((data) => {
                    <?php if (WPSHD_VCITA_DEBUG) { ?>console.log(data);<?php } ?>

                    if (avc != null) {
                        const av = data.availabilities;

                        if (av != undefined) {
                            if (Object.keys(av).length == 0) {
                                avc.innerHTML = '';
                                return
                            }

                            avc.innerHTML = '<table></table>';
                            avc = avc.lastElementChild;

                            const formatter = new Intl.DateTimeFormat('en-us', {
                                hour: 'numeric',
                                minute: 'numeric',
                                hour12: true,
                            });

                            for (let i in av) {
                                const l = av[i].length;
                                let day = new Date(i);
                                day = days[day.getDay()];
                                avc.insertAdjacentHTML('beforeend', '<tr><td>'+day+'</td><td></td></tr>');
                                const dc = avc.lastElementChild.lastElementChild.lastElementChild;

                                if (l > 0) {
                                    let ss = 0;

                                    for (let j=0; j<l; j++) {
                                        const dur = av[i][j].duration_minutes * 60 * 1000;
                                        const ds = new Date(av[i][j].start_time);

                                        if (ss == 0) {
                                            dc.insertAdjacentHTML('beforeend', formatter.format(ds));
                                            ss = 1;
                                        }

                                        ds.setTime(ds.getTime() + dur);

                                        if (j+1 < l) {
                                            const dn = new Date(av[i][j+1].start_time);

                                            if (dn.getTime() == ds.getTime()) {
                                                continue;
                                            } else {
                                                ss = 0;
                                                dc.insertAdjacentHTML('beforeend', ' - '+formatter.format(ds)+'&nbsp;&nbsp;');
                                            }
                                        } else {
                                            dc.insertAdjacentHTML('beforeend', ' - '+formatter.format(ds));
                                        }
                                    }
                                }
                            }
                        } else avc.innerHTML = 'Error: missing data';
                    } else avc.innerHTML = 'Error: missing data';
                })
                .catch((error) => {
                    console.log(error);
                    avc.innerHTML = 'error';
                });
        }

        function vcita_fetch_staff(add_preloader) {
            const e = document.querySelector('.vcita__services__list');
            if (e == null) return;
            if (add_preloader) e.innerHTML = VcitaUI.createPreloaderHTML();

            VcitaApi.getStaff()
                .then((resp1) => {
                    <?php if (WPSHD_VCITA_DEBUG) { ?>console.log(resp1);<?php } ?>
                    if (resp1.error) {
                        e.innerHTML = '<div>'+resp1.message+'</div>';
                        return;
                    }

                    const sl = resp1.staff.length;

                    if (sl <= 1) {
                        VcitaApi.getServices()
                            .then((resp2) => {
                                <?php if (WPSHD_VCITA_DEBUG) { ?>console.log(resp2);<?php } ?>
                                e.firstElementChild.remove();

                                if (resp2.services_data != undefined) {
                                    const l = resp2.services_data.length;

                                    e.insertAdjacentHTML('beforeend', '<table class="vcita__page__inner-table"><thead>' +
                                        '<tr><td>Service name</td><td>Service duration</td></tr></thead><tbody></tbody></table>');

                                    const tab = e.lastElementChild.lastElementChild;

                                    for (let i = 0; i < l; i++) {
                                        const s = resp2.services_data[i];

                                        tab.insertAdjacentHTML('beforeend', '<tr><td style="width:75%">'+s.name+'</td>' +
                                            '<td>'+s.duration+' minutes</td></tr>');
                                    }

                                    if (sl <= 1 && l <= 1) {
                                        vcita_fetch_availability(add_preloader);
                                    } else {
                                        const avc = document.getElementById('vcita__time__slots');
                                        if (avc != null)avc.innerHTML = '';
                                    }
                                }
                            })
                            .catch((err) => {
                                console.log(err);
                                e.innerHTML = '<div>Some error occured</div>';
                                const avc = document.getElementById('vcita__time__slots');
                                if (avc != null && avc) avc.innerHTML = '';
                            });
                    } else e.parentNode.remove();
                })
                .catch((serr) => {
                    console.log(serr);
                    e.innerHTML = '<div>Some error occured</div>';

                    const avc = document.getElementById('vcita__time__slots');
                    if (avc != null && avc.firstElementChild != null) avc.firstElementChild.remove();
                })
        }

        window.addEventListener('vcita_api_initialized', (ev) => {
            vcita_fetch_staff();
        });

        document.addEventListener('DOMContentLoaded', () => {
            VcitaMixpman.track('wp_sched_change_tab', { tab: 'main' });
        });

        function vcita_save_start_wizard(_this) {
            _this.classList.remove('clickme');
            const request = new XMLHttpRequest();
            request.open('GET', '/wp-admin/admin-ajax.php?action=vcita_save_data&data_name=start_wizard_clicked&data_val=1', true);
            request.send();
        }
    </script>
<?php } else { ?>
    <script type="text/javascript">
        document.addEventListener('DOMContentLoaded', () => {
            VcitaMixpman.track('main_visitor');
            VcitaMixpman.track('wp_sched_change_tab', { tab: 'main' });
            const vid = document.querySelector('.vcita__page__main-video');

            if (vid != null) {
                vid.addEventListener('click', function () {
                    if (this.lastElementChild.tagName == 'IMG') {
                        this.innerHTML = '<video controls preload="metadata" src="/wp-content/plugins/<?php echo WPSHD_VCITA_WIDGET_UNIQUE_ID; ?>/assets/media/video.mp4"></video>';
                        this.firstElementChild.addEventListener('play', () => { VcitaMixpman.track('wp_sched_watch_video') })
                        this.firstElementChild.play()
                    }
                })
            }
        })
    </script>
<?php } ?>
<?php } ?>
