<?php
	$wpshd_vcita_widget = (array) get_option(WPSHD_VCITA_WIDGET_KEY);
    $uid = $wpshd_vcita_widget["uid"];
?>
<script type="text/javascript">
    document.addEventListener('DOMContentLoaded', () => {
        VcitaMixpman.track('wp_sched_change_tab', { tab: 'support' });
    })
</script>
<div class="vcita-wrap" dir="ltr">
    <?php require_once WP_PLUGIN_DIR.'/'.WPSHD_VCITA_WIDGET_UNIQUE_ID.'/php_assets/admin_header.php'; ?>
	<div class="vcita__page__inner__section">
		<h3>
			Hi <?php if (!empty($uid)) echo !empty($wpshd_vcita_widget['name']) ? $wpshd_vcita_widget['name'] : $wpshd_vcita_widget['email']; ?>
			<small>No worries! We are here to assist</small>
		</h3>
	</div>
	<div class="vcita__page__inner__section-divided flex hspaced">
		<section>
			<div class="vcita__support__inner__section-banner-img flex vcentered hcentered">
				<img style="margin-bottom:13px" src="/wp-content/plugins/<?php echo WPSHD_VCITA_WIDGET_UNIQUE_ID ?>/images/assets/contact-us.svg" alt="contact us"/>
			</div>
			<h3 class="hcentered">
				Contact Us
				<small>Have questions? email our support team and get answers to any question you may have</small>
			</h3>
			<div class="hcentered"><a href="https://support.vcita.com/hc/en-us" target="_blank" onclick="VcitaMixpman.track('wp_sched_contact_support')">Contact Us</a></div>
		</section>
		<section>
			<div class="vcita__support__inner__section-banner-img flex vcentered hcentered">
				<img src="/wp-content/plugins/<?php echo WPSHD_VCITA_WIDGET_UNIQUE_ID ?>/images/assets/rate-us.svg" alt="rate us"/>
			</div>
			<h3 class="hcentered">
				Rate Us
				<small>Enjoying vcita Scheduling? Please rate us 5 stars and help us spread the word</small>
			</h3>
			<div class="hcentered"><a href="https://wordpress.org/support/plugin/meeting-scheduler-by-vcita/reviews/" target="_blank" onclick="VcitaMixpman.track('wp_sched_rate')">Rate Now</a></div>
		</section>
	</div>
	<div class="vcita__page__inner__section">
		<h3>Frequetly Asked Questions</h3>
		<div>
			<ul class="vcita__plus__list">
				<li>
					<input type="checkbox" class="vcita__plus__toggle"><label></label>
					<header>What is a service (also known as a meeting type / event type)?</header>
                    <section>When a client books a meeting he has to choose a meeting type (aka service) from your service list. Each new vCita account is configured with several default services that you can customize according to your needs. You can also create as many additional services as you require. To learn more click <a href="https://support.vcita.com/hc/en-us/articles/227896348-Configuring-your-services-menu" target="_blank">here</a>.</section>
				</li>
				<li>
					<input type="checkbox" class="vcita__plus__toggle"><label></label>
					<header>Can clients book an appointment with me outside my working hours?</header>
					<section>When using online scheduling your clients will be able to book an appointment at any time. However, you can customize the hours of availability to your liking. By default the set working days & hours are Mon-Fri 9am-5pm.</section>
				</li>
				<li>
					<input type="checkbox" class="vcita__plus__toggle"><label></label>
					<header>Can I set different working hours for certain dates?</header>
                    <section>Yes. You can change and alter your availability status according to your needs. Check it out <a href="https://app.vcita.com/app/settings/settings__my_availability" target="_blank">here</a></section>
				</li>
				<li>
					<input type="checkbox" class="vcita__plus__toggle"><label></label>
					<header>Can I set specific working days & hours for a specific service?</header>
					<section>Yes. you can customize and align your working hours per service to your availability. For example: if you provide manicure services only on Mondays and Thursdays you can define specific availability only for that service.</section>
				</li>
				<li>
					<input type="checkbox" class="vcita__plus__toggle"><label></label>
					<header>Do I need to confirm the meeting after a client schedules online?</header>
                    <section>By default the meeting requests are automatically accepted (i.e. your clients will get a booking confirmation right after they schedule). If you wish, you can turn off the auto accept feature and manually confirm / decline every meeting request.  Turn off auto accept <a href="https://app.vcita.com/app/settings/services?tab=settings" target="_blank">here</a></section>
				</li>
				<li>
					<input type="checkbox" class="vcita__plus__toggle"><label></label>
					<header>Can I send reminders to clients?</header>
                    <section>Yes, By default your clients will get a reminder email 30 minutes before the meeting. You can change how many minutes / hours / days in advance, they will get the alert. You can also create another reminder if needed. Reminders  can also be sent via sms. Customize your reminders <a href="https://app.vcita.com/app/settings/messages" target="_blank">here</a></section>
				</li>
                <li>
                    <input type="checkbox" class="vcita__plus__toggle"><label></label>
                    <header>Can I sync my calendar with vCita?</header>
                    <section>Yes, vCita’s calendar enables you to sync with all other calendars such as Gmail, iCal, Outlook etc. With a click of a button your vCita calendar will be integrated to your prepared calendar. You will be able to see all the meetings that are scheduled on vcita, and most importantly avoid double bookings. You can sync your calendar <a href="https://app.vcita.com/app/settings/calendar" target="_blank">here</a></section>
                </li>
                <li>
                    <input type="checkbox" class="vcita__plus__toggle"><label></label>
                    <header>I want to use vcita’s scheduling button just on specific pages on my site. Is it possible?</header>
                    <section>Yes. Instructions are available <a href="https://support.vcita.com/hc/en-us/articles/227892408-Add-the-Client-Portal-Widget-on-Selected-Pages-Wordpress" target="_blank">here</a></section>
                </li>
                <li>
                    <input type="checkbox" class="vcita__plus__toggle"><label></label>
                    <header>What information can I ask my clients to provide during scheduling?</header>
                    <section>vCita enables you to fully personalize your meeting form. You can ask your clients to provide any type of information while they schedule a meeting. For example: a phone number, address, date of birth etc. You can customize your meeting form <a href="https://app.vcita.com/app/settings/client_card" target="_blank">here</a></section>
                </li>
                <li>
                    <input type="checkbox" class="vcita__plus__toggle"><label></label>
                    <header>Is vcita HIPAA compliant?</header>
                    <section>Yes, vcita is HIPAA compliant.</section>
                </li>
                <li>
                    <input type="checkbox" class="vcita__plus__toggle"><label></label>
                    <header>More unanswered questions?</header>
                    <section>Head to <a href="https://www.vcita.com/FAQ" target="_blank">vcita.com/FAQ</a></section>
                </li>
			</ul>
		</div>
	</div>
    <?php require_once WP_PLUGIN_DIR.'/'.WPSHD_VCITA_WIDGET_UNIQUE_ID.'/php_assets/admin_footer.php'; ?>
</div>
<script type="text/javascript">
    jQuery('.vcita__plus__toggle').click(() => {
        VcitaMixpman.track('wp_sched_read_answer')
    })
</script>
